package agentes;

import jade.core.AID;
import jade.core.Agent;
import jade.domain.AMSService;
import jade.domain.FIPAAgentManagement.AMSAgentDescription;
import jade.domain.FIPAAgentManagement.SearchConstraints;
import jade.lang.acl.ACLMessage;

public class AgenteV2 extends Agent{

	public void sendMessage(String destino, String mensajea, String lenguaje){
		AID id = new AID(); 
		id.setLocalName(destino);
		ACLMessage mensaje = new ACLMessage(ACLMessage.REQUEST);
		 	
		mensaje.setSender(getAID());
        mensaje.setLanguage(lenguaje);
        mensaje.clearAllReceiver();
        mensaje.addReceiver(id);
        mensaje.setContent(mensajea);
        
        send(mensaje);
		}
	
	public void sendMessageBroadCast(String message, int type, Agent este, String lenguaje){
		AID myId = getAID();
		AMSAgentDescription [] agents = null;
		
		try {
			SearchConstraints constraints = new SearchConstraints();
			constraints.setMaxResults(new Long(-1));
			agents = AMSService.search(este, new AMSAgentDescription (), constraints );
		}catch (Exception e){
			System.out.println("Error "+ e);
		}
		
		ACLMessage msg = new ACLMessage(type);
		msg.setContent(message);
		msg.setLanguage(lenguaje);
		
		for (int i=0; i<agents.length;i++){
			if(!myId.getName().contentEquals(agents[i].getName().getName()))
				msg.addReceiver( agents[i].getName() );
		}
		
		
		send(msg);		
	
	}
	
}