package agentes;

import java.util.ArrayList;
import java.util.Iterator;

import comida.Comida;
import comida.ListaComidas;
import jade.core.AID;
import jade.core.Agent;
import jade.core.behaviours.Behaviour;
import jade.core.behaviours.CyclicBehaviour;
import jade.core.behaviours.OneShotBehaviour;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.lang.acl.ACLMessage;

public class Camarero extends Agent {

	ArrayList<Comida> comidas = new ArrayList<Comida>();
	boolean registrado=false;
	int trabajo = 0;
	
	 public void trabajoAdd(){
		 trabajo +=1;
	 }
	
	 public String getComida(){
		 Comida miComida=comidas.get(comidas.size()-1);
		 comidas.remove(comidas.size()-1);
		 return miComida.toString();
	 }
	 
	 DFAgentDescription descripcion = new DFAgentDescription();
     
     ServiceDescription servicio = new ServiceDescription();
   
    protected void setup(){
    	addBehaviour(new ReponerComida());
    	addBehaviour(new OfrecerComida());   	
    	addBehaviour(new ServirComida(this));
    }
     	   
    protected void takeDown(){
        System.out.println("fin");
    }
	
	private class ReponerComida extends CyclicBehaviour{

		@Override
		public void action() {
			if(comidas.size()==0){
				System.out.println("El camarero "+ getAID().getLocalName()+"  repuso comida ");
				while(comidas.size() < 10){	
					comidas.add(ListaComidas.getInstance().getComida());				
				}
				addBehaviour(new OfrecerComida());
			}
		}
	}
	
	private class OfrecerComida extends CyclicBehaviour{
		
		//Camarero este;
		
		@Override
		public void action(){
			if(!registrado){
				//
		        try{
		        	descripcion.setName(getAID());
		   	 		descripcion.addLanguages("Castellano");
				   	servicio.setType("Ofrecer comida");
				   	servicio.setName("Ofrecer comida");
				    descripcion.addServices(servicio);
		            DFService.register(myAgent, descripcion);
		            registrado = true;
		        }catch (FIPAException e){
		            e.printStackTrace();
		        }   
			}
			
			if(comidas.size()==0){
				try{
		            DFService.deregister(myAgent);
		            registrado = false;
		        }catch (FIPAException fe){
		            fe.printStackTrace();
		        }
		        System.out.println("El agente "+getAID().getLocalName()+" ya no ofrece sus servicios.");
		        addBehaviour(new ReponerComida());
			}
		}
	}
	
	private class ServirComida extends CyclicBehaviour{
		
		Camarero este;
		
		public ServirComida(Camarero este){
			this.este = este;
		}
		
		@Override
		public void action() {
			AID id = new AID();
			ACLMessage mensaje = receive(); 
			if(mensaje!= null && mensaje.getLanguage().equals("Castellano")){
				//sendMessage(mensaje.getSender().getLocalName(), getComida(), mensaje.getLanguage());
				System.out.println("El camarero "+ getAgent().getLocalName() + " recibio una peticion de comida. "+ mensaje.getSender().getLocalName());
				ACLMessage respuesta = new ACLMessage( ACLMessage.REQUEST );
				respuesta.setSender(getAID());
	       	 	respuesta.setLanguage("Castellano");
	       	 	respuesta.clearAllReceiver();
	       	 	trabajoAdd();
	       	 	respuesta.setContent(getComida());
	       	 	respuesta.addReceiver( mensaje.getSender() );
	       	 	send(respuesta);
			}		
			
			if(mensaje!= null && mensaje.getLanguage().equals("Austriaco")){
				System.out.println("------------------------------------------------------------------------");
				System.out.println("El camarero: " + este.getLocalName() + " hizo un total de:" + trabajo + " trabajos");
				System.out.println("------------------------------------------------------------------------");
			}
		}

	}
	
}