package agentes;

import jade.core.Agent;
import jade.core.behaviours.Behaviour;
import jade.core.behaviours.CyclicBehaviour;
import jade.core.behaviours.OneShotBehaviour;
import jade.domain.DFService;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.lang.acl.ACLMessage;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.StringTokenizer;

import comida.Comida;

public class Invitado extends AgenteV2 {

	private int lleno;
	private ArrayList <String> comidos = new ArrayList<String>();
	private boolean puerta=false;
	
	public ArrayList<String> getComidos(){
	return comidos;	}

	public int getLleno(){
	return lleno;	}

	private void recibirComida(String comida, int lleno){
	if(lleno<10){
		this.lleno=this.lleno+lleno;
		this.getComidos().add(comida);
	}
	
}
	
	protected void setup(){
		addBehaviour(new SaludarAnfitrion());
		addBehaviour(new SaludarInvitados(this));
		addBehaviour(new PedirComida(this));
		addBehaviour(new Recibir());
	}
//********************************************************************
//*************COMPORTAMIENTOS****************************************
//*********************************************************************
	
	private class SaludarAnfitrion extends OneShotBehaviour{

		@Override
		public void action() {
        	sendMessage("Aquiles Bailo", "Hola, gracias por la invitacion", "Bulgaro");
		}
		
	}
	
	private class SaludarInvitados extends OneShotBehaviour{

		Agent este;
		
		public SaludarInvitados(Agent este){
			this.este = este;
		}
		
		@Override
		public void action() {
			sendMessageBroadCast("Hola", 0, este, "Euskera");	
		}

	}
	
	private class PedirComida extends CyclicBehaviour{
		private Agent este;
		public PedirComida(Agent este ){
			this.este=este;
		}
		
		@Override
		public void action() {
			block(1000);
			ServiceDescription servicio = new ServiceDescription();
		    servicio.setType("Ofrecer comida");	 
	    // Plantilla de descripcion que busca el agente
	        DFAgentDescription descripcion = new DFAgentDescription();
	        descripcion.addLanguages("Castellano");
	    // Servicio que busca el agente
	        descripcion.addServices(servicio);
	        
	        
	        try{
	        // Todas las descripciones que encajan con la plantilla proporcionada en el DF
	            DFAgentDescription[] resultados = DFService.search(este,descripcion);
	            if (resultados.length == 0)
	                System.out.println("Ningun agente ofrece el servicio deseado");
	            if (getLleno()<=10)
	            	sendMessage(resultados[0].getName().getLocalName(), "Dame comida", "Castellano");
	            }
	        catch (Exception e){
		        System.out.println("Hubo un fallo");
		        e.printStackTrace();
		       }
		}//action
			
	}//pedircomida	
			
	private class Recibir extends CyclicBehaviour{
		public  void onStart(){
			System.out.println("El "+ myAgent.getLocalName()+" ha llegado.");
		}
		
		public void action() {
			ACLMessage respuesta = receive();
			if(respuesta!=null){
				String lenguaje = respuesta.getLanguage();
				switch (lenguaje) {
				case "Castellano"://Camarero--comida
						if(getLleno()<10){
							StringTokenizer st=new StringTokenizer(respuesta.getContent(),",");
			            	String comidaRecibida=st.nextToken();
			            	int llenoRecibido=Integer.parseInt(st.nextToken());
			                Invitado.this.recibirComida(comidaRecibida, llenoRecibido);
			                System.out.println("El camarero " + respuesta.getSender().getLocalName() + " ha servido " + comidaRecibida + " a " + this.getAgent().getLocalName()+" "+ getLleno());
			                addBehaviour(new PedirComida(myAgent));
						}				
					break;
				case "Euskera"://Saludo otros invitados
						System.out.println(myAgent.getLocalName() + ": Recibi un saludo de " + respuesta.getSender().getLocalName() + "  dijo: " + respuesta.getContent());
					break;
				case "Ruso"://Anfitrion--salir fiesta
						puerta=true;
					break;
				case "Portugues"://Anfition--Despedida
						System.out.println(myAgent.getLocalName() + ": Recibi un saludo de " + respuesta.getSender().getLocalName() + "  dijo: " + respuesta.getContent());
						doDelete();
					break;
				default:
					break;
				}//switch
				 if (puerta && lleno>10){
	         		sendMessageBroadCast("Adios", 0, myAgent, "Portugues");
	         	}
			}
		}//recibir
		
		
	}//recibir

	protected void takeDown() { 
		System.out.println("El "+getAID().getLocalName() + " abandona la fiesta");
			System.out.println("------------------------------------------------------------------------");
			System.out.println(this.getLocalName() + " comio la siguiente comida");
			Iterator<String> i = comidos.iterator();
			
			while(i.hasNext()){
				System.out.println(i.next());
			}

			System.out.println("------------------------------------------------------------------------");

	    }
	
}
